#! /bin/bash

CONF_FILE="./aams_block_domain.conf"

### Inclusione delle variabili di configurazione
. $CONF_FILE;

### Download del file in locazione temporanea
TEMP="/tmp/aams_block_domain_`date +%Y%m%d`.txt";
TEMP_MD5="$TEMP.md5";

curl -s -o $TEMP $URL;
curl -s -o $TEMP_MD5 $URL.md5;

if [ -f $LAST_UPDATE ] &&  diff $TEMP $LAST_UPDATE > /dev/null
then
	echo "UGUALI";
else
	# DIVERSI o PRIMA ESECUZIONE DELLO SCRIPT (LAST_UPDATE non esiste)

	# Controllo di sicurezza hash md5
	MD5_CALC=`md5sum $TEMP | cut -f1 -d' '`;
	MD5_ORIG=`cat $TEMP_MD5`;
	if [ $MD5_ORIG != $MD5_CALC ]
	then
		echo "MD5 Hash Mismatch;";
		echo "Il file scaricato da $URL risulta corrotto in quanto l'MD5 calcolato $MD5_CALC risulta diverso da quello pubblicato alla url $URL.md5 ($MD5_ORIG)"| mail -s "Aggiornamento AAMS - $HOSTNAME: MD5 MISMATCH" $MAIL;
	else
		#Controllo validità superato. Aggiornamento...	

		# Backup del file corrente se esiste (la prima volta che si esegue lo script il file non esiste)a
		if [ -f $LAST_UPDATE ]
		then
			cp $LAST_UPDATE ${LAST_UPDATE}_`date +%Y%m%d`;
		fi

		# Aggiornamento del file corrente
		cp -f $TEMP $LAST_UPDATE; 

		# Backup precedente file di zona
		cp $ZONE_FILE ${ZONE_FILE}_`date +%Y%m%d`;	
		# Creazione del file di zona
		echo "" > $ZONE_FILE;
		for domain in `cat $LAST_UPDATE | grep -v '^#'|sort -u`
		do
			echo 'zone "'$domain'" { type master; file "'$DUMMY_FILE'" ; }; ' >> $ZONE_FILE;
		done
		chown $BIND_USER $ZONE_FILE;
		echo "E' presente un nuovo aggiornamento dei siti bloccati da AAMS. Il risultato del check è il seguente:\n`named-checkconf`\n\nPer rendere effettive le modifiche è necessario riavviare il server BIND\n."|mail -s "Aggiornamento AAMS - $HOSTNAME : NUOVO AGGIORNAMENTO DA ATTIVARE" $MAIL;
	fi

fi


